<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <title>Mojitok Sample App</title>
    <!-- css -->
    <link rel="stylesheet" href="./index.css" />
  </head>

  <body>
    <!-- 1. Import React DOM -->
    <!-- 1. React DOM 추가 -->
    <script src="https://unpkg.com/react@16/umd/react.production.min.js" crossorigin></script>
    <script src="https://unpkg.com/react-dom@16/umd/react-dom.production.min.js" crossorigin></script>

    <!-- 2. Import UIKit component -->
    <!-- 2. UIKit 구성 요소 import -->
    <script src="./MojitokUIKit/index.js"></script>

    <div class="wrapper">
      <!-- 3. Declare tag to be used as MJTMainView, MJTRTSView Component -->
      <!-- 3. MJTMainView, MJTRTSView Component로 이용될 태그 선언 -->
      <div class="chat-list">
        <img src="./img/chat_list.svg" alt="background-chatlist" />
      </div>
      <div class="chat-data-wrapper">
        <div class="chat">
          <img src="./img/chat.svg" alt="background-chat" />
          <div class='sticker-preview-wrapper'>
            <img
              src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABAQMAAAAl21bKAAAAA1BMVEUAAACnej3aAAAAAXRSTlMAQObYZgAAAApJREFUCNdjYAAAAAIAAeIhvDMAAAAASUVORK5CYII="
              alt='sticker-preview'
              class='sticker-preview'
            />
          </div>
        </div>

        <div class="input-view-wrapper">
          <button id="emojiBtn" class="main-view-btn">😀</button>
          <div class="rts-view-wrapper">
            <div class="mjt-rts-view">
              <div id="mojitokRTSView"></div>
            </div>
            <div class="input-wrapper">
              <textarea id="textInput" class="input" placeholder="Enter Text" colum="2"></textarea>
            </div>
          </div>
        </div>
      </div>

      <div class="mjt-main-view-wrapper">
        <div id="mojitokMainView"></div>
      </div>
    </div>

    <script>
      const { MJTMainView, MJTRTSView, Mojitok } = MojitokUIKit;
      let isShowMjtMainView = false;

      // 4-1. Initialize Mojitok module
      // 4-1. Mojitok 모듈 초기화
      Mojitok.setup(
        '{YOUR-APP-ID}', // Application ID
      );

      // 4-2. Choose one of our payment platforms, currently “EXIMBAY” is supported, will be expanded later.
      // 4-2. 결제 플랫폼 선택. 현재 "EXIMBAY" 만 지원되며 추후 지원 플랫폼을 추가할 계획입니다.
      Mojitok.setPaymentPlatform("EXIMBAY");

      // 4-3. Set position and size of store web popup.
      // 4-3. 스토어 웹 팝업의 위치와 크기 설정
      Mojitok.setStoreGeometry(/* {POS-LEFT} */0, /* {POS-TOP} */0, /* {SIZE-WIDTH} */360, /* {SIZE-HEIGHT} */640); // Position and size of store web popup

      // 5. Mojitok module login (async(recommended) example, synchronous implementation is also possible)
      // 5. Mojitok 모듈 로그인 (비동기(권장) 예시이며, 동기 구현도 가능합니다)
      Mojitok.login(
        '{YOUR-APP-TOKEN}', // Application Token
        '{YOUR-APP-USER-ID}', // User ID of your app
        (e) => {
          if (e == null) {
            // 3-a. on Success
            // 3-a. 성공 시
          } else {
            // 3-b. on Fail: If the e.code value is 4001, then please check the applicationId or the applicationToken
            // 3-b. 실패 시: e.code 값이 4001이라면 applicationId 또는 Token을 확인해주세요
          }
        }
      );

      // 6. Write <choice> Callback function to be used for MJTMainView, MJTRTSView
      // 6. MJTMainView, MJTRTSView 에 사용할 <선택> Callback 함수 작성
      const handleStickerChoice = (mjtStickerInfo) => {
        const stickerPreviewElem = document.querySelector(".sticker-preview");
        stickerPreviewElem.setAttribute('src', mjtStickerInfo.url);
      };

      const inputElem = document.querySelector('#textInput');

      // 7. Add MJTRTSView Component
      // 7. MJTRTSView Component 추가
      const rtsView = document.getElementById('mojitokRTSView');

      inputElem.addEventListener('input', (e) => {
        ReactDOM.render(
          React.createElement(MJTRTSView, {
            width: 'inherit',
            height: '64px',
            text: e.target.value,
            onStickerChoice: handleStickerChoice,
          }),
          rtsView,
        );
      });

      if (isShowMjtMainView) {
        inputElem.classList.add('main-view-show-input');
      } else {
        inputElem.classList.remove('main-view-show-input');
      }

      const emjBtnElem = document.getElementById('emojiBtn');

      // 8. Add MJTMainView Component
      // 8. MJTMainView Component 추가
      const mainView = document.getElementById('mojitokMainView');
      ReactDOM.render(React.createElement(MJTMainView, { width: '350px', height: '300px', onStickerChoice: handleStickerChoice }), mainView);

      emjBtnElem.addEventListener('click', (e) => {
        isShowMjtMainView = !isShowMjtMainView;

        if (isShowMjtMainView) {
          emjBtnElem.classList.add('main-view-btn-selected');
          mainView.classList.add('display-view');
        } else {
          emjBtnElem.classList.remove('main-view-btn-selected');
          mainView.classList.remove('display-view');
        }
      });

      /* 9. Register a SentEvent when <sending> a <selected> sticker
       ..(example omitted).. // When the sticker is selected, the callback function is
       called, and Mojitok.addSendEvent(..) must be called on the received meta
       information. */

      /* 9. <선택>된 스티커의 meta정보를 <전송>시에 SentEvent로 등록
        ..(예제 생략).. // SDK에서 <선택>된 스티커의 meta정보를 App에서 넘겨받아,
        // 유저가 실제로 <전송>했을 때, 해당정보에 대해 Mojitok.addSendEvent(..) 호출
      */
    </script>
  </body>
</html>
